/// @cond EO_CXX_EO_IMPL

inline void elm::scroller::page_scroll_limit_set(int page_limit_h_, int page_limit_v_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_scroller_page_scroll_limit_set(page_limit_h_, page_limit_v_));
}

inline void elm::scroller::page_scroll_limit_get(int * page_limit_h_, int * page_limit_v_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_scroller_page_scroll_limit_get(page_limit_h_, page_limit_v_));
}

inline bool elm::scroller::propagate_events_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_scroller_propagate_events_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::scroller::propagate_events_set(bool propagation_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_scroller_propagate_events_set(::efl::eolian::to_c(propagation_)));
}

inline void elm::scroller::custom_widget_base_theme_set(::efl::eina::string_view klass_, ::efl::eina::string_view group_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_scroller_custom_widget_base_theme_set(::efl::eolian::to_c(klass_), ::efl::eolian::to_c(group_)));
}

inline void eo_cxx::elm::scroller::page_scroll_limit_set(int page_limit_h_, int page_limit_v_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_scroller_page_scroll_limit_set(page_limit_h_, page_limit_v_));
}

inline void eo_cxx::elm::scroller::page_scroll_limit_get(int * page_limit_h_, int * page_limit_v_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_scroller_page_scroll_limit_get(page_limit_h_, page_limit_v_));
}

inline bool eo_cxx::elm::scroller::propagate_events_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_scroller_propagate_events_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::scroller::propagate_events_set(bool propagation_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_scroller_propagate_events_set(::efl::eolian::to_c(propagation_)));
}

inline void eo_cxx::elm::scroller::custom_widget_base_theme_set(::efl::eina::string_view klass_, ::efl::eina::string_view group_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_scroller_custom_widget_base_theme_set(::efl::eolian::to_c(klass_), ::efl::eolian::to_c(group_)));
}

inline ::eo_cxx::elm::scroller::operator ::elm::scroller() const
{
   return *static_cast<::elm::scroller const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::scroller::operator ::elm::scroller&()
{
   return *static_cast<::elm::scroller*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::scroller::operator ::elm::scroller const&() const
{
   return *static_cast<::elm::scroller const*>(static_cast<void const*>(this));
}

template <typename T>
void elm_scroller_page_scroll_limit_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int page_limit_h_, int page_limit_v_)
{
   try
      {
         static_cast<T*>(self->this_)->page_scroll_limit_set(page_limit_h_, page_limit_v_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_scroller_page_scroll_limit_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int * page_limit_h_, int * page_limit_v_)
{
   try
      {
         static_cast<T*>(self->this_)->page_scroll_limit_get(page_limit_h_, page_limit_v_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_scroller_propagate_events_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->propagate_events_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_scroller_propagate_events_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool propagation_)
{
   try
      {
         static_cast<T*>(self->this_)->propagate_events_set(::efl::eolian::to_cxx<bool>(propagation_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_scroller_custom_widget_base_theme_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * klass_, const char * group_)
{
   try
      {
         static_cast<T*>(self->this_)->custom_widget_base_theme_set(::efl::eolian::to_cxx<::efl::eina::string_view>(klass_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::efl::eina::string_view>(group_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::scroller >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::layout >::template type<T>
         , virtual operations< ::elm_interface_scrollable >::template type<T>
         , virtual operations< ::elm_interface_atspi_widget_action >::template type<T>
         , virtual operations< ::evas::scrollable_interface >::template type<T>
   {
      virtual void page_scroll_limit_set(int page_limit_h_, int page_limit_v_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_scroller_page_scroll_limit_set(page_limit_h_, page_limit_v_));
      }

      virtual void page_scroll_limit_get(int * page_limit_h_, int * page_limit_v_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_scroller_page_scroll_limit_get(page_limit_h_, page_limit_v_));
      }

      virtual bool propagate_events_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_scroller_propagate_events_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void propagate_events_set(bool propagation_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_scroller_propagate_events_set(::efl::eolian::to_c(propagation_)));
      }

      virtual void custom_widget_base_theme_set(::efl::eina::string_view klass_, ::efl::eina::string_view group_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_scroller_custom_widget_base_theme_set(::efl::eolian::to_c(klass_), ::efl::eolian::to_c(group_)));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::scroller >
{
   static constexpr int value = 
#if defined(SCROLLER_PROTECTED) && defined(SCROLLER_BETA)
      5
#elif defined(SCROLLER_PROTECTED)
      5
#elif defined(SCROLLER_BETA)
      5
#else
      5
#endif
      + operation_description_class_size<::elm::layout >::value      + operation_description_class_size<::elm_interface_scrollable >::value      + operation_description_class_size<::elm_interface_atspi_widget_action >::value      + operation_description_class_size<::evas::scrollable_interface >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::scroller>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_scroller_page_scroll_limit_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_scroller_page_scroll_limit_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_scroller_page_scroll_limit_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_scroller_page_scroll_limit_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_scroller_propagate_events_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_scroller_propagate_events_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_scroller_propagate_events_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_scroller_propagate_events_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_scroller_custom_widget_base_theme_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_scroller_custom_widget_base_theme_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::layout>(), &ops[operation_description_class_size< ::elm::scroller >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::elm_interface_scrollable>(), &ops[operation_description_class_size< ::elm::scroller >::value + operation_description_class_size<::elm::layout>::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::elm_interface_atspi_widget_action>(), &ops[operation_description_class_size< ::elm::scroller >::value + operation_description_class_size<::elm::layout>::value + operation_description_class_size<::elm_interface_scrollable>::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::scrollable_interface>(), &ops[operation_description_class_size< ::elm::scroller >::value + operation_description_class_size<::elm::layout>::value + operation_description_class_size<::elm_interface_scrollable>::value + operation_description_class_size<::elm_interface_atspi_widget_action>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::scroller>)
{
   return (ELM_SCROLLER_CLASS);
}

} } }

/// @endcond

